require 'fiber'

class Effects
  def initialize(initial_handlers = {}, parent = nil, &block)
    @handlers = initial_handlers
    @fib = Fiber.new(&block)
    @parent = parent
    __next()
  end

  def self.with(**initial_handlers, &block)
    parent = nil
    begin
      Fiber.yield -> effector {
        parent = effector
      }
    rescue FiberError
      # Ignore it if it's Can't yield from Root fiber, for now? I guess
    end
    Effects.new(initial_handlers, parent, &block)
  end

  def self.listen(message, &handler)
    Fiber.yield -> effector {
      effector.__add_handler(message, &handler)
    }
  end

  def self.effection(message, *args)
    Fiber.yield -> effector {
      effector.__handle(message, *args)
    }
  end

  def effection(message, *args)
    Fiber.yield -> effector {
      effector.__handle(message, *args)
    }
  end

  def __next(*newVal)
    if @fib.alive?
      # This state is paused here and then will only be hit when the containing fiber calls Yield.
      cb = @fib.resume(*newVal)
      ret_val = cb
      if cb != nil and cb.respond_to? :call
        ret_val = cb.(self) 
      end
      __next(ret_val)
    end
  end

  def __add_handler(message, &handler)
    @handlers[message] = handler
  end

  def __handle(message, *args)
    if @handlers[message]
      res_with = @handlers[message].(*args)
    elsif @parent != nil
      res_with = @parent.effection(message, *args)
    end
  end
end
